diff --git a/tools/buildman/builder.py b/tools/buildman/builder.py
index 1b61e3a837..b7f2c426e3 100644
--- a/tools/buildman/builder.py
+++ b/tools/buildman/builder.py
@@ -17,12 +17,12 @@ import sys
 import threading
 import time
 
-import builderthread
+from buildman import builderthread
+from buildman import toolchain
 import command
 import gitutil
 import terminal
 from terminal import Print
-import toolchain
 
 """
 Theory of Operation
diff --git a/tools/buildman/control.py b/tools/buildman/control.py
index 7c8d7520fb..e05234c08f 100644
--- a/tools/buildman/control.py
+++ b/tools/buildman/control.py
@@ -5,18 +5,18 @@
 import multiprocessing
 import os
 import shutil
+import subprocess
 import sys
 
-import board
-import bsettings
-from builder import Builder
+from buildman import board
+from buildman import bsettings
+from buildman import toolchain
+from buildman.builder import Builder
+import command
 import gitutil
 import patchstream
 import terminal
 from terminal import Print
-import toolchain
-import command
-import subprocess
 
 def GetPlural(count):
     """Returns a plural 's' if count is not 1"""
diff --git a/tools/buildman/func_test.py b/tools/buildman/func_test.py
index 29b28f5a9f..9bfdd53698 100644
--- a/tools/buildman/func_test.py
+++ b/tools/buildman/func_test.py
@@ -8,11 +8,12 @@ import sys
 import tempfile
 import unittest
 
-import board
-import bsettings
-import cmdline
+from buildman import board
+from buildman import bsettings
+from buildman import cmdline
+from buildman import control
+from buildman import toolchain
 import command
-import control
 import gitutil
 import terminal
 import toolchain
diff --git a/tools/buildman/main.py b/tools/buildman/main.py
index 0add628a63..94d495c40b 100755
--- a/tools/buildman/main.py
+++ b/tools/buildman/main.py
@@ -6,6 +6,7 @@
 
 """See README for more information"""
 
+import doctest
 import multiprocessing
 import os
 import re
@@ -14,20 +15,19 @@ import unittest
 
 # Bring in the patman libraries
 our_path = os.path.dirname(os.path.realpath(__file__))
-sys.path.insert(1, os.path.join(our_path, '../patman'))
+sys.path.insert(1, os.path.join(our_path, '..'))
+sys.path.insert(2, os.path.join(our_path, '../patman'))
 
 # Our modules
-import board
-import bsettings
-import builder
-import checkpatch
-import cmdline
-import control
-import doctest
-import gitutil
+from buildman import board
+from buildman import bsettings
+from buildman import builder
+from buildman import cmdline
+from buildman import control
+from buildman import toolchain
 import patchstream
+import gitutil
 import terminal
-import toolchain
 
 def RunTests(skip_net_tests):
     import func_test
diff --git a/tools/buildman/test.py b/tools/buildman/test.py
index 8b6d138f70..87175eeb63 100644
--- a/tools/buildman/test.py
+++ b/tools/buildman/test.py
@@ -13,15 +13,15 @@ import unittest
 our_path = os.path.dirname(os.path.realpath(__file__))
 sys.path.append(os.path.join(our_path, '../patman'))
 
-import board
-import bsettings
-import builder
-import control
-import command
+from buildman import board
+from buildman import bsettings
+from buildman import builder
+from buildman import control
+from buildman import toolchain
 import commit
+import command
 import terminal
 import test_util
-import toolchain
 import tools
 
 use_network = True
diff --git a/tools/buildman/toolchain.py b/tools/buildman/toolchain.py
index 4456a805c7..a3540491ec 100644
--- a/tools/buildman/toolchain.py
+++ b/tools/buildman/toolchain.py
@@ -10,7 +10,7 @@ import sys
 import tempfile
 import urllib.request, urllib.error, urllib.parse
 
-import bsettings
+from buildman import bsettings
 import command
 import terminal
 import tools
diff --git a/tools/moveconfig.py b/tools/moveconfig.py
index d8bf7fd071..0dd8670403 100755
--- a/tools/moveconfig.py
+++ b/tools/moveconfig.py
@@ -314,11 +314,11 @@ import tempfile
 import threading
 import time
 
-sys.path.append(os.path.join(os.path.dirname(__file__), 'buildman'))
+sys.path.append(os.path.join(os.path.dirname(__file__), '..'))
 sys.path.append(os.path.join(os.path.dirname(__file__), 'patman'))
-import bsettings
-import kconfiglib
-import toolchain
+from buildman import bsettings
+from buildman import kconfiglib
+from buildman import toolchain
 
 SHOW_GNU_MAKE = 'scripts/show-gnu-make'
 SLEEP_TIME=0.03